﻿using System.Linq;
using System.Windows;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.ScheduleView;

namespace ScheduleView_CustomViewDefinition
{
	public class ResourceDependentAppointmentStyleSelector : OrientedAppointmentItemStyleSelector
	{
		private Style othersGamesStyle;
		private Style singlePlayGamesStyle;

		public Style OthersGamesStyle
		{
			get
			{
				return this.othersGamesStyle;
			}
			set
			{
				this.othersGamesStyle = value;
			}
		}

		public Style MySinglePlayGamesStyle
		{
			get
			{
				return this.singlePlayGamesStyle;
			}
			set
			{
				this.singlePlayGamesStyle = value;
			}
		}

		public override Style SelectStyle(object item, DependencyObject container, ViewDefinitionBase activeViewDefinition)
		{
			IAppointment appointment = item as IAppointment;
			if (appointment == null)
			{
				return base.SelectStyle(item, container, activeViewDefinition);
			}

			if (!OwnedByCurrentUser(appointment))
			{
				return this.OthersGamesStyle;
			}
			else
			{				
				return this.MySinglePlayGamesStyle;
			}
		}

		private static bool OwnedByCurrentUser(IAppointment appointment)
		{
			return appointment.Resources.OfType<IResource>().Any((IResource r) => r.ResourceType == "UserName" && r.ResourceName == User.CurrentUser);
		}

		private static bool CoachGame(IAppointment appointment)
		{
			return appointment.Resources.OfType<IResource>().Any((IResource r) => r.ResourceType == "Coach" && r.ResourceName == "Coach");
		}
	}
}